package uca.baptistearthur.geocaching.network

import com.google.gson.GsonBuilder
import okhttp3.OkHttpClient
import okhttp3.logging.HttpLoggingInterceptor
import retrofit2.Converter
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory
import uca.baptistearthur.geocaching.model.Address
import java.lang.reflect.Type


object AddressNetwork {
        private val base_url = "https://forward-reverse-geocoding.p.rapidapi.com/v1/reverse/"
        private val key = "19516a9900mshce10de76f99976bp10f192jsn8c8d82222baa"

        private val interceptor = HttpLoggingInterceptor().apply {
            level = HttpLoggingInterceptor.Level.BODY
        }

        private val gson = GsonBuilder().apply {
            registerTypeAdapter(Address::class.java, AddressDeserializer())
        }.create()

        private val client = OkHttpClient.Builder()
            .addInterceptor { chain ->
                val request = chain.request().newBuilder()
                    .addHeader("X-RapidAPI-Key", key)
                    .build()
                chain.proceed(request)
            }
            .addInterceptor(interceptor)
            .build()

        val retrofit: AddressAPI by lazy {
            Retrofit.Builder()
                .baseUrl(base_url)
                .client(client)
                .addConverterFactory(GsonConverterFactory.create(gson))
                .build()
                .create(AddressAPI::class.java)
        }
    }
