package uca.baptistearthur.geocaching.ui.overlay

import android.graphics.drawable.Drawable
import android.util.Log
import android.view.MotionEvent
import androidx.core.content.ContextCompat
import org.osmdroid.bonuspack.routing.OSRMRoadManager
import org.osmdroid.bonuspack.routing.RoadManager
import org.osmdroid.util.GeoPoint
import org.osmdroid.views.MapView
import org.osmdroid.views.overlay.Marker
import org.osmdroid.views.overlay.infowindow.InfoWindow
import uca.baptistearthur.geocaching.R

class PlaceMarker(val mapView: MapView, val parent : AddMarkerOverlay) : Marker(mapView) {

    override fun getTitle() = parent.getMarkerLabel(this)
    override fun onLongPress(e: MotionEvent?, mapView: MapView?): Boolean {
        if(mapView!=null && this.hitTest(e, mapView)) {
            parent.removeMarker(this)
            this.closeInfoWindow()
            mapView.overlays.remove(this)
            parent.computeIcons(mapView.context)
            parent.computeRoad(mapView)
            parent.computeNewRoadtripOverlay(mapView)
            mapView.invalidate()
            return true
        }
        return false
    }

}